// MP3InfoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "systrayplay.h"
#include "MP3InfoDlg.h"
#include "MainWnd.h"
#include "TagEditor.h"
#include "SeekDialog.h"
#include "PlaylistDlg.h"
#include "MainHelper.h"
#include "PlaylistManager.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CMainWnd* pMainFrame;
extern CMP3InfoDlg* MP3InfoDlg;
extern CSeekDialog* SeekDialog;
extern CPlaylistDlg* PlaylistDlg;

extern CStringArray genres;
extern Helper m_Helper;
extern PlaylistManager m_PlaylistManager;

/////////////////////////////////////////////////////////////////////////////
// CMP3InfoDlg dialog


CMP3InfoDlg::CMP3InfoDlg(UINT id, CWnd* pParent /*=NULL*/) : CDialog(id, pParent)
{
	m_album = _T("");
	m_artist = _T("");
	m_comment = _T("");
	m_filename = _T("");
	m_genre = _T("");
	m_title = _T("");
	m_year = _T("");
	m_bitrate = _T("");
	m_freq = _T("");
	m_mode = _T("");
}

CMP3InfoDlg::~CMP3InfoDlg()
{
	MP3InfoDlg = NULL;
}

CMP3InfoDlg* CMP3InfoDlg::getInstance(UINT id, CWnd* pParent)
{
	if (MP3InfoDlg != NULL && MP3InfoDlg->m_hWnd != NULL)
		MP3InfoDlg->SaveWindowPosAndDestroy();
	if (MP3InfoDlg != NULL && MP3InfoDlg->m_hWnd == NULL)
	{
		delete MP3InfoDlg;
		MP3InfoDlg = NULL;
	}
	if (MP3InfoDlg == NULL)
	{
		MP3InfoDlg = new CMP3InfoDlg(id, pParent);
		MP3InfoDlg->Create(id, pParent);
	}
	else
		MP3InfoDlg->SetFocus();
	return MP3InfoDlg;
}

IMPLEMENT_MENUXP(CMP3InfoDlg, CDialog)

BEGIN_MESSAGE_MAP(CMP3InfoDlg, CDialog)
ON_WM_CLOSE()
ON_BN_CLICKED(IDC_EDITTAG, OnEditTag)
ON_WM_SYSCOMMAND()
ON_MENUXP_MESSAGES()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMP3InfoDlg message handlers

void CMP3InfoDlg::DoDataExchange(CDataExchange* pDX)
{
	CMenuXP::SetXPLookNFeel(this, pMainFrame->XPLookNFeel);
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_ALBUM, m_album);
	DDX_Text(pDX, IDC_EDIT_ARTIST, m_artist);
	DDX_Text(pDX, IDC_EDIT_COMMENT, m_comment);
	DDX_Text(pDX, IDC_EDIT_FILENAME, m_filename);
	DDX_Text(pDX, IDC_EDIT_GENRE, m_genre);
	DDX_Text(pDX, IDC_EDIT_TITLE, m_title);
	DDX_Text(pDX, IDC_EDIT_YEAR, m_year);
	DDX_Text(pDX, IDC_EDIT_BITRATE, m_bitrate);
	DDX_Text(pDX, IDC_EDIT_FREQ, m_freq);
	DDX_Text(pDX, IDC_EDIT_MODE, m_mode);
	DDX_Control(pDX, IDC_EDITTAG, m_btn_EditTag);
}


void CMP3InfoDlg::ReadInfo()
{
	m_filename = m_PlaylistManager.GetPlaylist(pMainFrame->Current);

	CString mbuf = pMainFrame->MP3Info;
	m_bitrate = mbuf.Left(mbuf.Find('@'));
	mbuf = mbuf.Mid(mbuf.Find('@') + 1);
	m_freq = mbuf.Left(mbuf.Find('@'));
	m_mode = mbuf.Mid(mbuf.Find('@') + 1);

	if (PrevFile == m_filename)
	{
		UpdateData(FALSE);
		return;
	}
	PrevFile = m_filename;

	m_PlaylistManager.ReadTagAT(pMainFrame->Current);

	m_album = m_PlaylistManager.GetAlbum(pMainFrame->Current);
	m_artist = m_PlaylistManager.GetArtist(pMainFrame->Current);
	m_comment = m_PlaylistManager.GetComment(pMainFrame->Current);
	m_genre = m_PlaylistManager.GetGenre(pMainFrame->Current);
	m_title = m_PlaylistManager.GetTitle(pMainFrame->Current);
	m_year = m_PlaylistManager.GetYear(pMainFrame->Current);

	UpdateData(false);
}

void CMP3InfoDlg::OnCancel()
{
	SaveWindowPosAndDestroy();
}

void CMP3InfoDlg::OnClose()
{
	SaveWindowPosAndDestroy();
}

void CMP3InfoDlg::OnEditTag()
{
	CTagEditor TagEditor(IDD_TAGEDIT, this);

	TagEditor.m_album = m_PlaylistManager.GetAlbum(pMainFrame->Current);
	TagEditor.m_artist = m_PlaylistManager.GetArtist(pMainFrame->Current);
	TagEditor.m_comment = m_PlaylistManager.GetComment(pMainFrame->Current);
	TagEditor.m_filename = m_PlaylistManager.GetPlaylist(pMainFrame->Current);
	TagEditor.m_title = m_PlaylistManager.GetTitle(pMainFrame->Current);
	TagEditor.m_year = m_PlaylistManager.GetYear(pMainFrame->Current);
	TagEditor.m_genre = m_PlaylistManager.GetGenreI(pMainFrame->Current);

	if (TagEditor.DoModal() == IDOK)
	{
		m_PlaylistManager.Add(TagEditor.m_filename, pMainFrame->Current);
		PrevFile = "*";
		ReadInfo();
		if (PlaylistDlg != NULL && PlaylistDlg->m_hWnd != NULL)
			PlaylistDlg->m_playlistat.Invalidate();
	}
}

BOOL CMP3InfoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_Helper.translateWindowText(this, IDD_DIALOG_MP3INFO);
	m_Helper.translateDlgItemText(this, IDC_LFILENAME);
	m_Helper.translateDlgItemText(this, IDC_LBITRATE);
	m_Helper.translateDlgItemText(this, IDC_LKBPS);
	m_Helper.translateDlgItemText(this, IDC_LFREQ);
	m_Helper.translateDlgItemText(this, IDC_LHZ);
	m_Helper.translateDlgItemText(this, IDC_LMODE);
	m_Helper.translateDlgItemText(this, IDC_LTITLE);
	m_Helper.translateDlgItemText(this, IDC_LARTIST);
	m_Helper.translateDlgItemText(this, IDC_LALBUM);
	m_Helper.translateDlgItemText(this, IDC_LYEAR);
	m_Helper.translateDlgItemText(this, IDC_LCOMMENT);
	m_Helper.translateDlgItemText(this, IDC_LGENRE);
	m_Helper.translateDlgItemText(this, IDC_EDITTAG);

	SetIcon(pMainFrame->StpIcon, TRUE);
	SetIcon(pMainFrame->StpIconSm, FALSE);


	CRect rect1, rect2;
	::SystemParametersInfo(SPI_GETWORKAREA, 0, &rect1, 0);
	GetWindowRect(&rect2);
	if (pMainFrame->InfoX == -1000)
		pMainFrame->InfoX = (rect1.right - (rect2.right - rect2.left)) / 2;
	if (pMainFrame->InfoY == -1000)
		pMainFrame->InfoY = (rect1.bottom - (rect2.bottom - rect2.top)) / 2;
	if (pMainFrame->InfoX < 0)
		pMainFrame->InfoX = 0;
	if (pMainFrame->InfoY < 0)
		pMainFrame->InfoY = 0;
	if (pMainFrame->InfoX + (rect2.right - rect2.left) > rect1.right)
		pMainFrame->InfoX = rect1.right - (rect2.right - rect2.left);
	if (pMainFrame->InfoY + (rect2.bottom - rect2.top) > rect1.bottom)
		pMainFrame->InfoY = rect1.bottom - (rect2.bottom - rect2.top);
	SetWindowPos(NULL, pMainFrame->InfoX, pMainFrame->InfoY, 0, 0, SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, 9999, m_Helper.MyLoadString(IDS_ALWAYSONTOP));
	}
	if (pMainFrame->InfoOnTop == 1)
	{
		pSysMenu->CheckMenuItem(9999, MF_BYCOMMAND | MF_CHECKED);
		SetWindowPos(&wndTopMost, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE | SWP_NOACTIVATE);
	}
	else
		ModifyStyleEx(0, WS_EX_APPWINDOW);

	PrevFile = "*";

	ReadInfo();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CMP3InfoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if (nID == 9999)
	{
		if (pMainFrame->InfoOnTop == 1)
		{
			GetSystemMenu(FALSE)->CheckMenuItem(9999, MF_BYCOMMAND | MF_UNCHECKED);

			ShowWindow(SW_HIDE);
			ModifyStyleEx(0, WS_EX_APPWINDOW);
			ShowWindow(SW_SHOW);

			SetWindowPos(&wndNoTopMost, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE | SWP_NOACTIVATE);
			pMainFrame->InfoOnTop = 0;
		}
		else
		{
			GetSystemMenu(FALSE)->CheckMenuItem(9999, MF_BYCOMMAND | MF_CHECKED);

			ShowWindow(SW_HIDE);
			ModifyStyleEx(WS_EX_APPWINDOW, 0);
			ShowWindow(SW_SHOW);

			SetWindowPos(&wndTopMost, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE | SWP_NOACTIVATE);
			pMainFrame->InfoOnTop = 1;
		}
		if (SeekDialog != NULL && SeekDialog->m_hWnd != NULL)
			SeekDialog->SetWindowPos(&wndTopMost, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE | SWP_NOACTIVATE);
	}
	else
		CDialog::OnSysCommand(nID, lParam);
}

void CMP3InfoDlg::SaveWindowPosAndDestroy()
{
	ShowWindow(SW_RESTORE);
	CRect rect;
	GetWindowRect(&rect);
	pMainFrame->InfoX = rect.left;
	pMainFrame->InfoY = rect.top;

	DestroyWindow();
}

