// SettingApparenceTooltip.cpp : fichier d'implmentation
//

#include "stdafx.h"
#include "SysTrayPlay.h"
#include "SettingsDialog.h"
#include "SettingsDialogApparenceTooltip.h"
#include "MainHelper.h"
#include "MainWnd.h"
#include "Hotkeys.h"
#include "W2File.h"
#include "SeekDialog.h"
#include "EqualizerDlg.h"
#include "MP3InfoDlg.h"
#include "PlaylistDlg.h"
#include "AboutDlg.h"
#include "AutDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CSysTrayPlayApp theApp;
extern CMainWnd* pMainFrame;
extern Helper m_Helper;
extern CSettingsDialog* SettingsDialog;
extern CSeekDialog* SeekDialog;
extern CAboutDlg* AboutDialog;
extern CAutDlg* AutDlg;
extern CEqualizerDlg* EqualizerDlg;
extern CMP3InfoDlg* MP3InfoDlg;
extern CPlaylistDlg* PlaylistDlg;

// Bote de dialogue CSettingApparence

IMPLEMENT_MENUXP(CSettingsDialogApparenceTooltip, CPropertyPage);

IMPLEMENT_DYNAMIC(CSettingsDialogApparenceTooltip, CPropertyPage)

CSettingsDialogApparenceTooltip::CSettingsDialogApparenceTooltip() : CPropertyPage(IDD_SETTINGS_APPARENCE_TOOLTIP)
{
	m_border = pMainFrame->m_border;
	m_custom_border=pMainFrame->m_custom_border;
	m_end_bk.SetColour(pMainFrame->m_end_bk);
	m_border_width = pMainFrame->m_border_width;
	m_border_height= pMainFrame->m_border_height;
	m_border_color.SetColour(pMainFrame->m_border_color);
	m_start_bk.SetColour(pMainFrame->m_start_bk);
	m_mid_bk.SetColour(pMainFrame->m_mid_bk);
	m_effect_bk=pMainFrame->m_effect_bk;
	m_granularity=pMainFrame->m_granularity;
	m_transparency=pMainFrame->m_transparency;
	m_theme=pMainFrame->m_theme;

	m_show_time=pMainFrame->m_show_time;
	m_hide_time=pMainFrame->m_hide_time;
	m_fade_in=pMainFrame->m_fade_in;
	m_fade_out=pMainFrame->m_fade_out;
	m_animation=pMainFrame->m_animation;
}

CSettingsDialogApparenceTooltip::~CSettingsDialogApparenceTooltip()
{
}

void CSettingsDialogApparenceTooltip::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	CMenuXP::SetXPLookNFeel(this, pMainFrame->XPLookNFeel);
	DDX_Control(pDX, IDC_BUTTON4, m_border_color);
	DDX_Control(pDX, IDC_BUTTON3, m_end_bk);
	DDX_Control(pDX, IDC_BUTTON2, m_mid_bk);
	DDX_Control(pDX, IDC_BUTTON1, m_start_bk);
	DDX_CBIndex(pDX, IDC_COMBO2, m_theme);
	DDX_CBIndex(pDX, IDC_COMBO1, m_effect_bk);
	DDX_Text(pDX, IDC_EDIT1, m_granularity);
	DDV_MinMaxByte(pDX, m_granularity, 0, 255);
	DDX_Check(pDX, IDC_CHECK1, m_border);
	DDX_Radio(pDX, IDC_RADIO1, m_custom_border);
	DDX_Text(pDX, IDC_EDIT5, m_border_width);
	DDX_Text(pDX, IDC_EDIT6, m_border_height);
	DDX_Text(pDX, IDC_EDIT7, m_transparency);
	DDX_Text(pDX, IDC_EDIT4, m_show_time);
	DDX_Text(pDX, IDC_EDIT2, m_hide_time);
	DDX_Text(pDX, IDC_EDIT9, m_fade_in);
	DDX_Text(pDX, IDC_EDIT10, m_fade_out);
	DDX_Text(pDX, IDC_EDIT11, m_animation);
}

BOOL CSettingsDialogApparenceTooltip::OnInitDialog()
{
	CPropertyPage::OnInitDialog();
	CMenuXP::SetXPLookNFeel(this, pMainFrame->XPLookNFeel);

	m_Helper.translateWindowText(this, IDD_SETTINGS_APPARENCE_TOOLTIP);
	m_Helper.translateDlgItemText(this, IDC_LBACKGROUNDEFFECT);
	m_Helper.translateDlgItemText(this, IDC_LTYPE);
	m_Helper.translateDlgItemText(this, IDC_LSTART);
	m_Helper.translateDlgItemText(this, IDC_LMID);
	m_Helper.translateDlgItemText(this, IDC_LEND);
	m_Helper.translateDlgItemText(this, IDC_LGRANULARITY);
	m_Helper.translateDlgItemText(this, IDC_LTRANSPARENCY);
	m_Helper.translateDlgItemText(this, IDC_LCOLORS);
	m_Helper.translateDlgItemText(this, IDC_LCOLORTHEME);
	m_Helper.translateDlgItemText(this, IDC_LTIMERS);
	m_Helper.translateDlgItemText(this, IDC_LBORDER);
	m_Helper.translateDlgItemText(this, IDC_LWIDTH);
	m_Helper.translateDlgItemText(this, IDC_LHEIGHT);
	m_Helper.translateDlgItemText(this, IDC_LSHOWAFTER);
	m_Helper.translateDlgItemText(this, IDC_LHIDEAFTER);
	m_Helper.translateDlgItemText(this, IDC_LFADEIN);
	m_Helper.translateDlgItemText(this, IDC_LFADEOUT);
	m_Helper.translateDlgItemText(this, IDC_LANIMATION);
	m_Helper.translateDlgItemText(this, IDC_CHECK1);
	m_Helper.translateDlgItemText(this, IDC_RADIO1);
	m_Helper.translateDlgItemText(this, IDC_RADIO2);
	m_Helper.translateDlgItemText(this, IDC_LOOK_TOOLTIP);

/*
	CWnd* pWnd = GetDlgItem(IDC_EDIT1);
	pWnd->SetWindowText(toolTipText);
	((CSpinButtonCtrl *)GetDlgItem(IDC_SPIN2))->SetRange(1, 99);
*/
	m_tooltip.Create(this);

	m_tooltip.AddTool(GetDlgItem(IDC_LOOK_TOOLTIP), SettingsDialog->m_SettingsDialogApparence.toolTipText);
	m_tooltip.SetNotify();
	
	OnChangeColorTheme();
	OnChangeEffect();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CSettingsDialogApparenceTooltip::OnOK()
{
	UpdateData(TRUE);

	pMainFrame->m_border_color=m_border_color.GetColour();
	pMainFrame->m_end_bk=m_end_bk.GetColour();
	pMainFrame->m_mid_bk=m_mid_bk.GetColour();
	pMainFrame->m_start_bk=m_start_bk.GetColour();

	pMainFrame->m_theme=m_theme;
	pMainFrame->m_effect_bk=m_effect_bk;
	pMainFrame->m_granularity=m_granularity;
	pMainFrame->m_border=m_border;
	pMainFrame->m_custom_border=m_custom_border;
	pMainFrame->m_border_width=m_border_width;
	pMainFrame->m_border_height=m_border_height;
	pMainFrame->m_transparency=m_transparency;
	pMainFrame->m_show_time=m_show_time;
	pMainFrame->m_hide_time=m_hide_time;
	pMainFrame->m_fade_in=m_fade_in;
	pMainFrame->m_fade_out=m_fade_out;
	pMainFrame->m_animation=m_animation;

	CPropertyPage::OnOK();
}

BEGIN_MESSAGE_MAP(CSettingsDialogApparenceTooltip, CPropertyPage)
	ON_CBN_SELCHANGE(IDC_COMBO2, OnChangeColorTheme)
	ON_CBN_SELCHANGE(IDC_COMBO1, OnChangeEffect)
	ON_BN_CLICKED(IDC_CHECK1, OnShowBorder)
	ON_EN_CHANGE(IDC_EDIT1, OnChangeEffect)
	ON_EN_CHANGE(IDC_EDIT5, OnSetBorder)
	ON_EN_CHANGE(IDC_EDIT6, OnSetBorder)
	ON_BN_CLICKED(IDC_RADIO1, OnSetBorder)
	ON_BN_CLICKED(IDC_RADIO2, OnSetBorder)
	ON_EN_CHANGE(IDC_EDIT7, OnChangeTransparency)
	ON_EN_CHANGE(IDC_EDIT4, OnChangeTimers)
	ON_EN_CHANGE(IDC_EDIT2, OnChangeTimers)
	ON_EN_CHANGE(IDC_EDIT9, OnChangeTimers)
	ON_EN_CHANGE(IDC_EDIT10, OnChangeTimers)
	ON_EN_CHANGE(IDC_EDIT11, OnChangeAniStep)
END_MESSAGE_MAP()

LONG CSettingsDialogApparenceTooltip::OnChangeColorBk(UINT lParam, LONG wParam)
{
	m_tooltip.SetColorBk(m_start_bk.GetColour(), m_mid_bk.GetColour(), m_end_bk.GetColour());
	OnSetBorder();
	return 0L;
}

void CSettingsDialogApparenceTooltip::OnChangeColorTheme() 
{
	UpdateData();
	switch(m_theme)
	{
	case 0:
		//Standard
		m_start_bk.SetColour(RGB(255, 255, 223));
		m_mid_bk.SetColour(RGB(192, 192, 172));
		m_end_bk.SetColour(RGB(128, 128, 112));
		break;
	case 1:
		//Silver
		m_start_bk.SetColour(RGB(255, 255, 255));
		m_mid_bk.SetColour(RGB(240, 247, 255));
		m_end_bk.SetColour(RGB(192, 192, 208));
		break;
	case 2:
		//Button
		m_start_bk.SetColour(RGB(223, 223, 223));
		m_mid_bk.SetColour(RGB(191, 191, 191));
		m_end_bk.SetColour(RGB(127, 127, 127));
		break;
	case 3:
		//Exotic
		m_start_bk.SetColour(RGB(0, 255, 255));
		m_mid_bk.SetColour(RGB(255, 255, 0));
		m_end_bk.SetColour(RGB(0, 255, 0));
		break;
	case 4:
		//Aqua
		m_start_bk.SetColour(RGB(123, 158, 198));
		m_mid_bk.SetColour(RGB(173, 207, 247));
		m_end_bk.SetColour(RGB(198, 239, 255));
		break;
	case 5:
		//Chrome
		m_start_bk.SetColour(RGB(231, 251, 255));
		m_mid_bk.SetColour(RGB(214, 211, 214));
		m_end_bk.SetColour(RGB(165, 162, 173));
		break;
	case 6:
		//Gold
		m_start_bk.SetColour(RGB(255, 255, 148));
		m_mid_bk.SetColour(RGB(255, 231, 132));
		m_end_bk.SetColour(RGB(255, 207, 0));
		break;
	case 7:
		//Sunny
		m_start_bk.SetColour(RGB(255, 248, 229));
		m_mid_bk.SetColour(RGB(255, 209, 115));
		m_end_bk.SetColour(RGB(255, 156, 0));
		break;
	case 8:
		//Jungle
		m_start_bk.SetColour(RGB(214, 250, 183));
		m_mid_bk.SetColour(RGB(148, 236, 104));
		m_end_bk.SetColour(RGB(4, 202, 0));
		break;
	case 9:
		//Sky
		m_start_bk.SetColour(RGB(203, 233, 254));
		m_mid_bk.SetColour(RGB(88, 175, 241));
		m_end_bk.SetColour(RGB(0, 67, 202));
		break;
	case 10:
		//Fire
		m_start_bk.SetColour(RGB(255, 255, 0));
		m_mid_bk.SetColour(RGB(255, 104, 32));
		m_end_bk.SetColour(RGB(194, 3, 0));
		break;
	}
	OnChangeColorBk();
}

void CSettingsDialogApparenceTooltip::OnChangeEffect() 
{
	UpdateData();
	m_tooltip.SetEffectBk(m_effect_bk, m_granularity);
}

void CSettingsDialogApparenceTooltip::OnShowBorder() 
{
	OnSetBorder();
}

void CSettingsDialogApparenceTooltip::OnSetBorder() 
{
	UpdateData();
	m_border_color.EnableWindow(m_border);
	GetDlgItem(IDC_BUTTON4)->EnableWindow(m_border);
	GetDlgItem(IDC_RADIO1)->EnableWindow(m_border);
	GetDlgItem(IDC_RADIO2)->EnableWindow(m_border);
	GetDlgItem(IDC_EDIT5)->EnableWindow(m_border);
	GetDlgItem(IDC_EDIT6)->EnableWindow(m_border);
	if (m_border)
	{
		if (!m_custom_border)
			m_tooltip.SetBorder(m_end_bk.GetColour(), m_border_width, m_border_height);
		else
			m_tooltip.SetBorder(m_border_color.GetColour(), m_border_width, m_border_height);
	}
	else
	{
		m_tooltip.HideBorder();
	} //if
}

BOOL CSettingsDialogApparenceTooltip::PreTranslateMessage(MSG* pMsg) 
{
	m_tooltip.RelayEvent(pMsg);

	return CPropertyPage::PreTranslateMessage(pMsg);
}

void CSettingsDialogApparenceTooltip::OnChangeTransparency()
{
	UpdateData();
	m_tooltip.SetTransparency(m_transparency);
}

void CSettingsDialogApparenceTooltip::OnChangeTimers() 
{
	UpdateData();
	m_tooltip.SetDelayTime(PPTOOLTIP_TIME_INITIAL, m_show_time);
	m_tooltip.SetDelayTime(PPTOOLTIP_TIME_AUTOPOP, m_hide_time);
	m_tooltip.SetDelayTime(PPTOOLTIP_TIME_FADEIN, m_fade_in);
	m_tooltip.SetDelayTime(PPTOOLTIP_TIME_FADEOUT, m_fade_out);
}

void CSettingsDialogApparenceTooltip::OnChangeAniStep() 
{
	UpdateData();
	m_tooltip.SetDelayTime(PPTOOLTIP_TIME_ANIMATION, m_animation);
}
