// SettingApparence.cpp : fichier d'implmentation
//

#include "stdafx.h"
#include "SysTrayPlay.h"
#include "SettingsDialog.h"
#include "SettingsDialogApparence.h"
#include "MainHelper.h"
#include "MainWnd.h"
#include "Hotkeys.h"
#include "W2File.h"
#include "SeekDialog.h"
#include "EqualizerDlg.h"
#include "MP3InfoDlg.h"
#include "PlaylistDlg.h"
#include "AboutDlg.h"
#include "AutDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CSysTrayPlayApp theApp;
extern CMainWnd* pMainFrame;
extern Helper m_Helper;
extern CSettingsDialog* SettingsDialog;
extern CSeekDialog* SeekDialog;
extern CAboutDlg* AboutDialog;
extern CAutDlg* AutDlg;
extern CEqualizerDlg* EqualizerDlg;
extern CMP3InfoDlg* MP3InfoDlg;
extern CPlaylistDlg* PlaylistDlg;

// Bote de dialogue CSettingApparence

IMPLEMENT_MENUXP(CSettingsDialogApparence, CPropertyPage);

IMPLEMENT_DYNAMIC(CSettingsDialogApparence, CPropertyPage)

CSettingsDialogApparence::CSettingsDialogApparence() : CPropertyPage(IDD_SETTINGS_APPARENCE)
{
	startColor.SetColour(pMainFrame->startColor);
	endColor.SetColour(pMainFrame->endColor);
	showGradient = pMainFrame->showGradient ? TRUE : FALSE;
	showToolTip = pMainFrame->showToolTip ? TRUE : FALSE;
	toolTipText = pMainFrame->toolTipText;
	toolTipText.Replace(_T("\\r\\n"), _T("\r\n"));
	toolTipText.Replace(_T("\\t"), _T("\t"));
}

CSettingsDialogApparence::~CSettingsDialogApparence()
{
}

void CSettingsDialogApparence::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	CMenuXP::SetXPLookNFeel(this, pMainFrame->XPLookNFeel);
	DDX_Control(pDX, IDC_GRADIENTSTART, startColor);
	DDX_Control(pDX, IDC_GRADIENTEND, endColor);
	DDX_Check(pDX, IDC_SHOWGRADIENT, showGradient);
	DDX_Check(pDX, IDC_SHOWTOOLTIP, showToolTip);
	DDX_Text(pDX, IDC_EDIT1, toolTipText);
}

BOOL CSettingsDialogApparence::OnInitDialog()
{
	CPropertyPage::OnInitDialog();
	CMenuXP::SetXPLookNFeel(this, pMainFrame->XPLookNFeel);

	m_Helper.translateWindowText(this, IDD_SETTINGS_APPARENCE);
	m_Helper.translateDlgItemText(this, IDC_LGRADIENTSTART);
	m_Helper.translateDlgItemText(this, IDC_LGRADIENTEND);
	m_Helper.translateDlgItemText(this, IDC_SHOWGRADIENT);
	m_Helper.translateDlgItemText(this, IDC_SHOWTOOLTIP);
	m_Helper.translateDlgItemText(this, IDC_LCONTENTTOOLTIP);
	m_Helper.translateDlgItemText(this, IDC_LSECONDS);

	CWnd* pWnd = GetDlgItem(IDC_EDIT1);
	pWnd->SetWindowText(toolTipText);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}
void CSettingsDialogApparence::OnPaint()
{
	CPropertyPage::OnPaint();
	CPaintDC dc(this);
	DrawGradientSample();
}

void CSettingsDialogApparence::OnOK()
{
	UpdateData(TRUE);

	pMainFrame->showGradient = (showGradient == TRUE);
	pMainFrame->showToolTip = (showToolTip == TRUE);
	pMainFrame->startColor = startColor.GetColour();
	pMainFrame->endColor = endColor.GetColour();
	pMainFrame->toolTipText = toolTipText;
	pMainFrame->toolTipText.Replace(_T("\r\n"), _T("\\r\\n"));
	pMainFrame->toolTipText.Replace(_T("\n"), _T("\\n"));
	pMainFrame->toolTipText.Replace(_T("\t"), _T("\\t"));

	//Invalidation de toutes les boites de dialogues
	if (AboutDialog != NULL && AboutDialog->m_hWnd != NULL)
	{
		AboutDialog->CloseWindow();
		AboutDialog = AboutDialog->getInstance(IDD_ABOUT);
	}
	if (AutDlg != NULL && AutDlg->m_hWnd != NULL)
	{
		AutDlg->DestroyWindow();
		AutDlg = AutDlg->getInstance(IDD_AUTOMATION);
	}
	if (EqualizerDlg != NULL && EqualizerDlg->m_hWnd != NULL)
	{
		EqualizerDlg->SaveWindowPosAndDestroy();
		EqualizerDlg = EqualizerDlg->getInstance(IDD_EQUALIZER_DIALOG);
	}
	if (MP3InfoDlg != NULL && MP3InfoDlg->m_hWnd != NULL)
	{
		MP3InfoDlg->SaveWindowPosAndDestroy();
		MP3InfoDlg = MP3InfoDlg->getInstance(IDD_DIALOG_MP3INFO);
	}
	if (PlaylistDlg != NULL && PlaylistDlg->m_hWnd != NULL)
	{
		PlaylistDlg->SaveWindowPosAndDestroy();
		PlaylistDlg = PlaylistDlg->getInstance(IDD_PLAYLIST);
	}
	if (SeekDialog != NULL && SeekDialog->m_hWnd != NULL)
	{
		SeekDialog->SaveWindowPosAndDestroy();
		SeekDialog = SeekDialog->getInstance(IDD_SEEK);
	}

	CPropertyPage::OnOK();
}

void CSettingsDialogApparence::DrawGradientSample()
{
	CWnd* pWnd = GetDlgItem(IDC_GRADIENTSAMPLE);
	if (pWnd)
	{
		CDC* pDC = pWnd->GetDC();
		HDC hDC = ::GetWindowDC(pWnd->m_hWnd);
		CRect rect;
		pWnd->GetClientRect(&rect);

		HBITMAP bm = CreateCompatibleBitmap(hDC, rect.Width(), rect.Height());
		rect.bottom--;
		rect.right--;
		SelectObject(hDC, bm);

		SeekDialog->DrawGradient(CDC::FromHandle(hDC), startColor.GetColour(), endColor.GetColour(), &rect);
		pDC->StretchBlt(0, 0, rect.Width(), rect.Height(), CDC::FromHandle(hDC), 0, 0, rect.Width(), rect.Height(), SRCPAINT);
		CPen pen(PS_SOLID, 1, RGB(0, 0, 0));
		pDC->SelectObject(pen);
		pDC->MoveTo(rect.TopLeft());
		pDC->LineTo(CPoint(rect.right, rect.top));
		pDC->LineTo(rect.BottomRight());
		pDC->LineTo(CPoint(rect.left, rect.bottom));
		pDC->LineTo(rect.TopLeft());
		::ReleaseDC(pWnd->m_hWnd, hDC);
		DeleteObject(hDC);
	}
}

void CSettingsDialogApparence::OnChangeTooltipText() {
	UpdateData();
	SettingsDialog->m_SettingsDialogApparenceTooltip.m_tooltip.AddTool(SettingsDialog->m_SettingsDialogApparenceTooltip.GetDlgItem(IDC_LOOK_TOOLTIP), toolTipText);
}

BEGIN_MESSAGE_MAP(CSettingsDialogApparence, CPropertyPage)
	ON_EN_CHANGE(IDC_EDIT1, OnChangeTooltipText)
	ON_WM_PAINT()
END_MESSAGE_MAP()
