#ifndef ARGS_H
#define ARGS_H

#include "common.h"
#include "main.h"
#include "streamManager.h"

struct al_table
{
	short bits;
	short d;
};

class MPArgs
{
private:
	StreamManager* streamManage;
public:
	unsigned long CurrentPos;   // Current player position in frames
	int CurrentPosMs;   // Current player position in ms
	unsigned long SampleRate;   // Samplerate
	unsigned long BufferSize;   // The size of the output buffer
	unsigned long Buffers;    // The number of buffers 
	int InpBufFrames;   		// Number of frames for input buffering
	long Channels;  	  // Channels(1=mono;2=stereo)
	long AudioBits; 	  // Bits per sample(ex. 16 bit)
	long ScaleFactor;   	// Output scale factor(ex. 32768 which is normal)
	bool Seekable;  	  // Is the stream seekable?
	long OutDeviceNum;  	// Device number for MMSystem output
	long ForceMono; 	  // Force mono output?
	long DownSample;	  // Downsample Modes
	bool UseEqualizer;  	// Activate equalizer? 
	bool PauseFlag; 		//Flag de pause

	HWND wnd;

	MPArgs()
	{
		streamManage = new StreamManager();
		OutDeviceNum = 0;
		CurrentPos = 0;
		CurrentPosMs = 0;
		// No downsampling
		DownSample = 0;
		// Force Stereo output
		AudioBits = 16;
		SampleRate = 44100;
		Channels = 2;
		BufferSize = 16384;
		Buffers = 8;
		InpBufFrames = 100;
		Seekable = true;
		ForceMono = 0;
		ScaleFactor = 32768;
		UseEqualizer = false;
		wnd = NULL;
	}

	~MPArgs()
	{
		delete streamManage;
	}
	StreamManager* getStreamManager()
	{
		return streamManage;
	}
};

typedef int (*synthProc)(real*, int, char*, int*);
typedef int (*synth_monoProc)(real*, char*, int*);

struct frame
{
	synthProc synth;
	synth_monoProc synth_mono;

	int framesize;

	long stereo;
	long jsbound;
	long single;
	long II_sblimit;
	long lsf;
	long mpeg25;
	unsigned long block_size;
	long lay;
	long error_protection;
	long bitrate_index;
	long sampling_frequency;
	long padding;
	long extension;
	long mode;
	long mode_ext;
	long copyright;
	long original;
	long emphasis;
};

#endif